
// Name
//===================================
//
// Background
//


// DEPENDENCIES
//===================================

    #include "background.h"
    #include "camera.h"


// STATIC PROPERTIES
//===================================


// METHODS
//===================================

    Background::Background
    (
        Graphics::SpriteSheet texture,
        int width,
        int height,
        int offset_x,
        int offset_y,
        double scroll_speed_x,
        double scroll_speed_y
    )
    :
        texture_ ( texture ),
        width_ ( width ),
        height_ ( height ),
        offset_x_ ( offset_x ),
        offset_y_ ( offset_y ),
        x_ ( offset_x ),
        y_ ( offset_y ),
        scroll_speed_x_ ( scroll_speed_x ),
        scroll_speed_y_ ( scroll_speed_y )
    {};

    Background::~Background() {};

    void Background::render( Graphics& graphics, Camera& camera )
    {
        if ( texture_ >= 0 && texture_ < Graphics::SpriteSheet::LIMIT )
        {
            /*
            int left = offset_x_ + ( camera.x() % camera.widthPixels() );
            int right = width_ - left;
            int right2 = std::min( width_, camera.widthPixels() - right );

            std::cout<<"L: "<<left<<std::endl;
            std::cout<<"R: "<<right<<std::endl;

            SDL_Rect dest = { 0, 0, right, camera.heightPixels() };
            SDL_Rect source = { left, 0, right, camera.heightPixels() };

            SDL_Rect dest2 = { right, 0, right2, camera.heightPixels() };
            SDL_Rect source2 = { 0, 0, right2, camera.heightPixels() };


            graphics.renderObject( texture_, source, dest );
            graphics.renderObject( texture_, source2, dest2 );
            */

            int sl = offset_x_ + ( (int)( camera.x() * scroll_speed_x_ ) % width_ );
            int dl = 0;
            int right = std::min( width_ - sl, camera.widthPixels() );
            int far_right = 0;

            SDL_Rect dest = { dl, 0, right, camera.heightPixels() };
            SDL_Rect source = { sl, 0, right, camera.heightPixels() };

            graphics.renderObject( texture_, source, dest );

            while ( far_right < camera.widthPixels() )
            {
                far_right += right;
                dl += right;
                right = std::min( width_, camera.widthPixels() - dl );

                dest = { dl, 0, right, camera.heightPixels() };
                source = { 0, 0, right, camera.heightPixels() };

                graphics.renderObject( texture_, source, dest );
            }

        }
    };
