

// Name
//===================================
//
// Background
//

#ifndef BACKGROUND_H
#define BACKGROUND_H


// FORWARD DECLARATIONS
//===================================

    class Camera;


// DEPENDENCIES
//===================================

    #include "graphics.h"


// CLASS
//===================================

    class Background
    {
        public:
            Background
            (
                Graphics::SpriteSheet texture = Graphics::SpriteSheet::LIMIT,
                int width = -1,
                int height = -1,
                int offset_x = 0,
                int offset_y = 0,
                double scroll_speed_x = 1,
                double scroll_speed_y = 1
            );
            ~Background();
            void render( Graphics& graphics, Camera& camera );

        private:
            Graphics::SpriteSheet texture_ = Graphics::SpriteSheet::CHARSET;
            int x_;
            int y_;
            int width_;
            int height_;
            int offset_x_;
            int offset_y_;
            double scroll_speed_x_;
            double scroll_speed_y_;
    };

#endif // BACKGROUND_H
