

// Name
//===================================
//
// Goal
//

#ifndef GOAL_H
#define GOAL_H


// FORWARD DECLARATIONS
//===================================

    class EventSystem;
    class Inventory;


// DEPENDENCIES
//===================================

    #include <string>


// CLASS
//===================================

    class Goal
    {

        public:
            enum GoalType
            {
                NORMAL,
                COLLECT,
                TIMED
            };

            Goal( GoalType type = GoalType::NORMAL, int value = 0 );
            ~Goal();

            virtual void update( Inventory& inventory, EventSystem& events );
            virtual std::string message();

            GoalType type() const;
            int value() const;

        protected:
            GoalType type_;
            int value_;
    };

#endif // GOAL_H
