


// Name
//===================================
//
// HydrantMovement
//

#ifndef HYDRANT_MOVEMENT_H
#define HYDRANT_MOVEMENT_H


// FORWARD DECLARATIONS
//===================================

    class Block;
    class Input;
    class Sprite;


// DEPENDENCIES
//===================================

    #include "sprite_movement.h"
    #include "timers/timer_simple.h"


// CLASS
//===================================

    class HydrantMovement : public SpriteMovement
    {
        public:
            ~HydrantMovement();
            void update( Sprite& sprite, Input& input, Camera& camera, Map& lvmap, SpriteGraphics* graphics, Game& game, EventSystem& events );
            void interact( Collision& collision, Sprite& sprite, Sprite& other );

            int delayValue() const;

        private:
            bool awake_ = false;
            TimerSimple delay_ = TimerSimple( 32, false );
    };


#endif // HYDRANT_MOVEMENT_H
