


// Name
//===================================
//
// TitleState
//


// DEPENDENCIES
//===================================

    #include "game.h"
    #include "input.h"
    #include "level_select_state.h"
    #include "title_state.h"


// STATIC PROPERTIES
//===================================


// METHODS
//===================================

    TitleState::TitleState() : GameState( StateID::TITLE_STATE ) {};

    TitleState::~TitleState() {};

    void TitleState::update( Game& game, Input& input, Graphics& graphics )
    {/*
        for ( auto &t : text_ )
        {
            t.update();
        }*/

        for ( int i = 0; i < text_.size(); ++i )
        {
            text_[ i ].update();
        }

        if ( input.pressed( Input::Action::CONFIRM ) )
        {
            game.changeState( std::unique_ptr<GameState> ( new LevelSelectState() ) );
            //game.changeState( std::unique_ptr<GameState> ( new LevelState( true, Level::LevelName::LV_SEWER_1 ) ) );
        }

        if ( input.pressed( Input::Action::MENU ) )
        {
            game.quit();
        }
    };

    void TitleState::stateRender( Graphics& graphics )
    {/*
        for ( auto& t : text_ )
        {
            t.render( graphics );
        }*/

        for ( int i = 0; i < text_.size(); ++i )
        {
            text_[ i ].render( graphics );
        }
        logo_gfx_.render( graphics, logo_rect_, nullptr );
    };

    void TitleState::init( Game& game, Graphics& graphics )
    {
    };

    void TitleState::backFromPop( Game& game, Graphics& graphics ) {};
