




// Name
//===================================
//
// Warp
//


// DEPENDENCIES
//===================================

    #include "unit.h"
    #include "warp.h"
    #include <iostream>


// STATIC PROPERTIES
//===================================

// METHODS
//===================================

    Warp::Warp
    (
        int map_num,
        int entrance_x,
        int entrance_y,
        int warp_location_blocks_left,
        int warp_location_blocks_right,
        int warp_location_blocks_top,
        int warp_location_blocks_bottom,
        int camera_x,
        int camera_y
    )
    :
        map_num_ ( map_num ),
        entrance_x_ ( entrance_x ),
        entrance_y_ ( entrance_y ),
        warp_location_blocks_left_ ( warp_location_blocks_left ),
        warp_location_blocks_right_ ( warp_location_blocks_right ),
        warp_location_blocks_top_ ( warp_location_blocks_top ),
        warp_location_blocks_bottom_ ( warp_location_blocks_bottom ),
        camera_x_ ( camera_x ),
        camera_y_ ( camera_y )
    {};

    Warp::~Warp() {};

    int Warp::mapNum() const
    {
        return map_num_;
    };

    int Warp::entranceX() const
    {
        return entrance_x_;
    };

    int Warp::entranceY() const
    {
        return entrance_y_;
    };

    int Warp::cameraX() const
    {
        return camera_x_;
    };

    int Warp::cameraY() const
    {
        return camera_y_;
    };

    Direction::Horizontal Warp::direction() const
    {
        return direction_;
    };

    bool Warp::inInterval( int x_sub_pixels, int y_sub_pixels )
    {
        int x = Unit::SubPixelsToBlocks( x_sub_pixels );
        int y = Unit::SubPixelsToBlocks( y_sub_pixels );

        if
        (
            x >= warp_location_blocks_left_  &&
            x <= warp_location_blocks_right_ &&
            y >= warp_location_blocks_top_   &&
            y <= warp_location_blocks_bottom_
        )
        {
            return true;
        }

        return false;
    };
