



// Name
//===================================
//
// Warp
//

#ifndef WARP_H
#define WARP_H


// FORWARD DECLARATIONS
//===================================


// DEPENDENCIES
//===================================

    #include "direction.h"


// CLASS
//===================================

    class Warp
    {
        public:
            Warp
            (
                int map_num,
                int entrance_x,
                int entrance_y,
                int warp_location_blocks_left,
                int warp_location_blocks_right,
                int warp_location_blocks_top,
                int warp_location_blocks_bottom,
                int camera_x = -1,
                int camera_y = -1
            );
            ~Warp();

            int mapNum() const;
            int entranceX() const;
            int entranceY() const;
            int cameraX() const;
            int cameraY() const;
            Direction::Horizontal direction() const;
            bool inInterval( int x_sub_pixels, int y_sub_pixels );

        private:
            int map_num_;
            int entrance_x_;
            int entrance_y_;
            int warp_location_blocks_left_;
            int warp_location_blocks_right_;
            int warp_location_blocks_top_;
            int warp_location_blocks_bottom_;
            Direction::Horizontal direction_ = Direction::Horizontal::__NULL;
            int camera_x_;
            int camera_y_;
    };

#endif // WARP_H
